/* -*- tab-width:4; -*- */
/* FILE interface: test
 */
#include "s.h"

int SOBJ_T_FILE;

SOBJ scm_file2obj(int type, void *p)
{
	SOBJ new = scm_newcell(SOBJ_T_FILE);
	SCM_AUX(new) = p;
	return(new);
}

void *scm_obj2file(SOBJ x)
{
	return(SCM_AUX(x));
}

void scm_file_sweep(SOBJ x)
{
  printf("scm_file_sweep: type=%d, aux=%p\n", x->type, SCM_AUX(x));
  if (SCM_AUX(x) != NULL)
	fclose(SCM_AUX(x));
  SCM_AUX(x)=NULL;
}

SOBJ scm_file_compare(SOBJ x, SOBJ y)
{
  return(SCM_AUX(x) == SCM_AUX(y) ? scm_true : scm_false);
}

SOBJ_TYPE_DESCR scm_file_type = {
  0,							/* nothing here */
  "file",						/* type name */
  NULL,							/* code to mark */
  scm_file_sweep,				/* code to sweep */
  NULL,							/* howto print */
  NULL,							/* howto write */
  NULL,							/* char reconizer */
  NULL,							/* char parser */
  NULL,							/* word reconizer */
  NULL,							/* word parser */
  scm_file_compare,				/* type value comparison */
  scm_file2obj,					/* cast to obj */
  scm_obj2file,					/* cast to file */
};  


void scm_init_file()
{
  SOBJ_T_FILE = scm_add_type(&scm_file_type);
}

